
// build number
#define VERSIONCHECK	41
// also change VERSION #define string in game.c
#define COMPMAGIC	1235
// if adding magic, then modify magic check in comp.c to tell user
// about old file no longer supported

#define MAXGAMEEVENTS	128

// compile only
void SaveConComp(FILE *fil, char *scripptrs);

// run only
void LoadCompCode(long fil, char *scripptrs);
void SetSystemVarPointers();

// general
char IsGameEvent(short i);
char AddGameVar(char *pszLabel, long lValue, unsigned long dwFlags);

#define MAX_COMPHEADERSTRING 128

extern char g_szCompCreator[MAX_COMPHEADERSTRING];
extern char g_szCompCopyright[MAX_COMPHEADERSTRING];
extern long g_lKey;

extern short line_number;
extern long *apScriptGameEvent[MAXGAMEEVENTS];
extern long *actorLoadEventScrptr[MAXTILES];

extern bDebugFunStuff;

extern short g_i;
extern short g_p;
extern long g_x;
extern long *g_t;
extern spritetype *g_sp;


extern MATTGAMEVAR aDefaultGameVars[MAXGAMEVARS];	// the 'original' values
extern int iDefaultGameVarCount;

typedef struct _voxel_map
{
	int voxnum;
	char name[13]; // 8.3+\0
} t_voxel_map;

extern t_voxel_map voxel_map[MAXTILES];
void VoxelInit(void);
void VoxelLoadVoxels(void);

void ReadGameVars(long fil);
void SaveGameVars(FILE *fil);
void DumpGameVars(FILE *fp);

char AddGameVar(char *pszLabel, long lValue, unsigned long dwFlags);
int GetGameID(char *szGameLabel);
long GetDefID(char *szGameLabel);
void FreeGameVars(void);
void ClearGameVars(void);
void AddSystemVars();
void ClearGameEvents();





#define PLAYER_ZOOM 1
#define PLAYER_EXITX 2
#define PLAYER_EXITY 3
#define PLAYER_LOOGIEX 4
#define PLAYER_LOOGIEY 5
#define PLAYER_NUMLOOGS 6
#define PLAYER_LOOGCNT 7
#define PLAYER_POSX 8
#define PLAYER_POSY 9
#define PLAYER_POSZ 10
#define PLAYER_HORIZ 11
#define PLAYER_OHORIZ 12
#define PLAYER_OHORIZOFF 13
#define PLAYER_INVDISPTIME 14
#define PLAYER_BOBPOSX 15
#define PLAYER_BOBPOSY 16
#define PLAYER_OPOSX 17
#define PLAYER_OPOSY 18
#define PLAYER_OPOSZ 19
#define PLAYER_PYOFF 20
#define PLAYER_OPYOFF 21
#define PLAYER_POSXV 22
#define PLAYER_POSYV 23
#define PLAYER_POSZV 24
#define PLAYER_LAST_PISSED_TIME 25
#define PLAYER_TRUEFZ 26
#define PLAYER_TRUECZ 27
#define PLAYER_PLAYER_PAR 28
#define PLAYER_VISIBILITY 29
#define PLAYER_BOBCOUNTER 30
#define PLAYER_WEAPON_SWAY 31
#define PLAYER_PALS_TIME 32
#define PLAYER_RANDOMFLAMEX 33
#define PLAYER_CRACK_TIME 34
#define PLAYER_AIM_MODE 35
#define PLAYER_ANG 36
#define PLAYER_OANG 37
#define PLAYER_ANGVEL 38
#define PLAYER_CURSECTNUM 39
#define PLAYER_LOOK_ANG 40
#define PLAYER_LAST_EXTRA 41
#define PLAYER_SUBWEAPON 42
#define PLAYER_AMMO_AMOUNT 43
#define PLAYER_WACKEDBYACTOR 44
#define PLAYER_FRAG 45
#define PLAYER_FRAGGEDSELF 945
#define PLAYER_CURR_WEAPON 46
#define PLAYER_LAST_WEAPON 47
#define PLAYER_TIPINCS 48
#define PLAYER_HORIZOFF 49
#define PLAYER_WANTWEAPONFIRE 50
#define PLAYER_HOLODUKE_AMOUNT 51
#define PLAYER_NEWOWNER 52
#define PLAYER_HURT_DELAY 53
#define PLAYER_HBOMB_HOLD_DELAY 54
#define PLAYER_JUMPING_COUNTER 55
#define PLAYER_AIRLEFT 56
#define PLAYER_KNEE_INCS 57
#define PLAYER_ACCESS_INCS 58
#define PLAYER_FTA 59
#define PLAYER_FTQ 60
#define PLAYER_ACCESS_WALLNUM 61
#define PLAYER_ACCESS_SPRITENUM 62
#define PLAYER_KICKBACK_PIC 63
#define PLAYER_GOT_ACCESS 64
#define PLAYER_WEAPON_ANG 65
#define PLAYER_FIRSTAID_AMOUNT 66
#define PLAYER_SOMETHINGONPLAYER 67
#define PLAYER_ON_CRANE 68
#define PLAYER_I 69
#define PLAYER_ONE_PARALLAX_SECTNUM 70
#define PLAYER_OVER_SHOULDER_ON 71
#define PLAYER_RANDOM_CLUB_FRAME 72
#define PLAYER_FIST_INCS 73
#define PLAYER_ONE_EIGHTY_COUNT 74
#define PLAYER_CHEAT_PHASE 75
#define PLAYER_DUMMYPLAYERSPRITE 76
#define PLAYER_EXTRA_EXTRA8 77
#define PLAYER_QUICK_KICK 78
#define PLAYER_HEAT_AMOUNT 79
#define PLAYER_ACTORSQU 80
#define PLAYER_TIMEBEFOREEXIT 81
#define PLAYER_CUSTOMEXITSOUND 82
#define PLAYER_WEAPRECS 83
#define PLAYER_WEAPRECCNT 84
#define PLAYER_INTERFACE_TOGGLE_FLAG 85
#define PLAYER_ROTSCRNANG 86
#define PLAYER_DEAD_FLAG 87
#define PLAYER_SHOW_EMPTY_WEAPON 88
#define PLAYER_SCUBA_AMOUNT 89
#define PLAYER_JETPACK_AMOUNT 90
#define PLAYER_STEROIDS_AMOUNT 91
#define PLAYER_SHIELD_AMOUNT 92
#define PLAYER_HOLODUKE_ON 93
#define PLAYER_PYCOUNT 94
#define PLAYER_WEAPON_POS 95
#define PLAYER_FRAG_PS 96
#define PLAYER_TRANSPORTER_HOLD 97
#define PLAYER_LAST_FULL_WEAPON 98
#define PLAYER_FOOTPRINTSHADE 99
#define PLAYER_BOOT_AMOUNT 100
#define PLAYER_SCREAM_VOICE 101
#define PLAYER_GM 102
#define PLAYER_ON_WARPING_SECTOR 103
#define PLAYER_FOOTPRINTCOUNT 104
#define PLAYER_HBOMB_ON 105
#define PLAYER_JUMPING_TOGGLE 106
#define PLAYER_RAPID_FIRE_HOLD 107
#define PLAYER_ON_GROUND 108
#define PLAYER_NAME 109
#define PLAYER_INVEN_ICON 110
#define PLAYER_BUTTONPALETTE 111
#define PLAYER_JETPACK_ON 112
#define PLAYER_SPRITEBRIDGE 113
#define PLAYER_LASTRANDOMSPOT 114
#define PLAYER_SCUBA_ON 115
#define PLAYER_FOOTPRINTPAL 116
#define PLAYER_HEAT_ON 117
#define PLAYER_HOLSTER_WEAPON 118
#define PLAYER_FALLING_COUNTER 119
#define PLAYER_GOTWEAPON 120
#define PLAYER_REFRESH_INVENTORY 121
#define PLAYER_PALETTE 122
#define PLAYER_TOGGLE_KEY_FLAG 123
#define PLAYER_KNUCKLE_INCS 124
#define PLAYER_WALKING_SND_TOGGLE 125
#define PLAYER_PALOOKUP 126
#define PLAYER_HARD_LANDING 127
#define PLAYER_MAX_SECRET_ROOMS 128
#define PLAYER_SECRET_ROOMS 129
#define PLAYER_PALS 130
#define PLAYER_MAX_ACTORS_KILLED 131
#define PLAYER_ACTORS_KILLED 132
#define PLAYER_RETURN_TO_CENTER 133




#define USERDEFS_GOD 2
#define USERDEFS_WARP_ON 3
#define USERDEFS_CASHMAN 4
#define USERDEFS_EOG 5
#define USERDEFS_SHOWALLMAP			 6
#define USERDEFS_SHOW_HELP 7
#define USERDEFS_SCROLLMODE 8
#define USERDEFS_CLIPPING 9
#define USERDEFS_USER_NAME 10
#define USERDEFS_RIDECULE 11
#define USERDEFS_SAVEGAME 12
#define USERDEFS_PWLOCKOUT 13
#define USERDEFS_RTSNAME 14
#define USERDEFS_OVERHEAD_ON 15
#define USERDEFS_LAST_OVERHEAD 16
#define USERDEFS_SHOWWEAPONS 17
#define USERDEFS_PAUSE_ON 18
#define USERDEFS_FROM_BONUS 19
#define USERDEFS_CAMERASPRITE 20
#define USERDEFS_LAST_CAMSPRITE 21
#define USERDEFS_LAST_LEVEL 22
#define USERDEFS_SECRETLEVEL 23
#define USERDEFS_CONST_VISIBILITY 24
#define USERDEFS_UW_FRAMERATE 25
#define USERDEFS_CAMERA_TIME 26
#define USERDEFS_FOLFVEL 27
#define USERDEFS_FOLAVEL 28
#define USERDEFS_FOLX 29
#define USERDEFS_FOLY 30
#define USERDEFS_FOLA 31
#define USERDEFS_RECCNT 32
#define USERDEFS_ENTERED_NAME 33
#define USERDEFS_SCREEN_TILTING 34
#define USERDEFS_SHADOWS 35
#define USERDEFS_FTA_ON 36
#define USERDEFS_EXECUTIONS 37
#define USERDEFS_AUTO_RUN 38
#define USERDEFS_COORDS 39
#define USERDEFS_TICKRATE 40
#define USERDEFS_M_COOP 41
#define USERDEFS_COOP 42
#define USERDEFS_SCREEN_SIZE 43
#define USERDEFS_LOCKOUT 44
#define USERDEFS_CROSSHAIR 45
#define USERDEFS_WCHOICE 46
#define USERDEFS_PLAYERAI 47
#define USERDEFS_RESPAWN_MONSTERS 48
#define USERDEFS_RESPAWN_ITEMS 49
#define USERDEFS_RESPAWN_INVENTORY 50
#define USERDEFS_RECSTAT 51
#define USERDEFS_MONSTERS_OFF 52
#define USERDEFS_BRIGHTNESS 53
#define USERDEFS_M_RESPAWN_ITEMS 54
#define USERDEFS_M_RESPAWN_MONSTERS 55
#define USERDEFS_M_RESPAWN_INVENTORY 56
#define USERDEFS_M_RECSTAT 57
#define USERDEFS_M_MONSTERS_OFF 58
#define USERDEFS_DETAIL 59
#define USERDEFS_M_FFIRE 60
#define USERDEFS_FFIRE 61
#define USERDEFS_M_PLAYER_SKILL 62
#define USERDEFS_M_LEVEL_NUMBER 63
#define USERDEFS_M_VOLUME_NUMBER 64
#define USERDEFS_MULTIMODE 65
#define USERDEFS_PLAYER_SKILL 66
#define USERDEFS_LEVEL_NUMBER 67
#define USERDEFS_VOLUME_NUMBER 68
#define USERDEFS_M_MARKER 69
#define USERDEFS_MARKER 70
#define USERDEFS_MOUSEFLIP 71


#define CON_GAMEVAR	112
#define CON_IFVARL	113
#define CON_IFVARG	114
#define CON_SETVARVAR	115
#define CON_SETVAR	116
#define CON_ADDVARVAR	117
#define CON_ADDVAR	118
#define CON_IFVARVARL	119
#define CON_IFVARVARG	120
#define CON_ADDLOGVAR	121
#define CON_ADDLOG	122
#define CON_ONEVENT	123
#define CON_ENDEVENT	124
#define CON_IFVARE	125
#define CON_IFVARVARE	126
#define CON_SPGETLOTAG	127
#define CON_SPGETHITAG	128
#define CON_SECTGETLOTAG	129
#define CON_SECTGETHITAG	130
#define CON_IFSOUND	131
#define CON_GETTEXTUREFLOOR	132
#define CON_GETTEXTURECEILING	133
#define CON_GETTEXTUREWALL	134
#define CON_STARTTRACK	135
#define CON_RANDVAR	136
#define CON_ENHANCED	137
#define CON_GETANGLETOTARGET	138
#define CON_GETACTORANGLE	139
#define CON_SETACTORANGLE	140
#define CON_MULVAR	141
#define CON_MULVARVAR	142
#define CON_DIVVAR	143
#define CON_DIVVARVAR	144
#define CON_MODVAR	145
#define CON_MODVARVAR	146
#define CON_ANDVAR	147
#define CON_ANDVARVAR	148
#define CON_ORVAR	149
#define CON_ORVARVAR	150
#define CON_GETPLAYERANGLE	151
#define CON_SETPLAYERANGLE	152
#define CON_LOCKPLAYER	153
#define CON_SETSECTOR	154
#define CON_GETSECTOR	155
#define CON_SETACTOR	156
#define CON_GETACTOR	157
#define CON_SETWALL	158
#define CON_GETWALL	159
#define CON_FINDNEARACTOR	160
#define CON_FINDNEARACTORVAR	161
#define CON_SETACTORVAR	162
#define CON_GETACTORVAR	163
#define CON_ESPAWN	164
#define CON_GETPLAYER	165
#define CON_SETPLAYER	166
#define CON_SQRT	167
#define CON_EVENTLOADACTOR	168
#define CON_ESPAWNVAR	169
#define CON_GETUSERDEF	170
#define CON_SETUSERDEF	171
#define CON_SUBVARVAR	172
#define CON_SUBVAR	173
#define CON_IFVARN	174
#define CON_IFVARVARN	175
#define CON_IFVARAND	176
#define CON_IFVARVARAND	177
#define CON_MYOS	178
#define CON_MYOSPAL	179
#define CON_SWITCH	180
#define CON_CASE	181
#define CON_DEFAULT	182
#define CON_ENDSWITCH	183
#define CON_DISPLAYRAND	184
#define CON_SIN	185
#define CON_XORVARVAR 186
#define CON_XORVAR	187
#define CON_RANDVARVAR 188
#define CON_MYOSX	189
#define CON_MYOSPALX 190
#define CON_GMAXAMMO 191
#define CON_SMAXAMMO 192
#define CON_MAPVOXEL 193
#define CON_STARTLEVEL	194

#ifdef EDUKE
#define NUMKEYWORDS	195
#else
#ifdef WW2
#define NUMKEYWORDS		127
#else
#define NUMKEYWORDS		112
#endif
#endif

#define SECTOR_WALLPTR	1
#define SECTOR_WALLNUM	2
#define SECTOR_CEILINGZ	3
#define SECTOR_FLOORZ	4
#define SECTOR_CEILINGSTAT	5
#define SECTOR_FLOORSTAT	6
#define SECTOR_CEILINGPICNUM 7
#define SECTOR_CEILINGSLOPE 8
#define SECTOR_CEILINGSHADE 9
#define SECTOR_CEILINGPAL 10
#define SECTOR_CEILINGXPANNING 11
#define SECTOR_CEILINGYPANNING 12
#define SECTOR_FLOORPICNUM 13
#define SECTOR_FLOORSLOPE 14
#define SECTOR_FLOORSHADE 15
#define SECTOR_FLOORPAL 16
#define SECTOR_FLOORXPANNING 17
#define SECTOR_FLOORYPANNING 18
#define SECTOR_VISIBILITY 19
#define SECTOR_ALIGNTO 20
#define SECTOR_LOTAG 21
#define SECTOR_HITAG 22
#define SECTOR_EXTRA 23


#define WALL_X 1
#define WALL_Y 2
#define WALL_POINT2 3
#define WALL_NEXTWALL 4
#define WALL_NEXTSECTOR 5
#define WALL_CSTAT 6
#define WALL_PICNUM 7
#define WALL_OVERPICNUM 8
#define WALL_SHADE 9
#define WALL_PAL 10
#define WALL_XREPEAT 11
#define WALL_YREPEAT 12
#define WALL_XPANNING 13
#define WALL_YPANNING 14
#define WALL_LOTAG 15
#define WALL_HITAG 16
#define WALL_EXTRA 17


#define ACTOR_X 1
#define ACTOR_Y 2
#define ACTOR_Z 3
#define ACTOR_CSTAT 4
#define ACTOR_PICNUM 5
#define ACTOR_SHADE 6
#define ACTOR_PAL 7
#define ACTOR_CLIPDIST 8
#define ACTOR_DETAIL 9
#define ACTOR_XREPEAT 10
#define ACTOR_YREPEAT 11
#define ACTOR_XOFFSET 12
#define ACTOR_YOFFSET 13
#define ACTOR_SECTNUM 14
#define ACTOR_STATNUM 15
#define ACTOR_ANG 16
#define ACTOR_OWNER 17
#define ACTOR_XVEL 18
#define ACTOR_YVEL 19
#define ACTOR_ZVEL 20
#define ACTOR_LOTAG 21
#define ACTOR_HITAG 22
#define ACTOR_EXTRA 23
#define ACTOR_HTCGG 50
#define ACTOR_HTPICNUM 51
#define ACTOR_HTANG 52
#define ACTOR_HTEXTRA 53
#define ACTOR_HTOWNER 54
#define ACTOR_HTMOVFLAG 55
#define ACTOR_HTTEMPANG 56
#define ACTOR_HTACTORSTAYPUT 57
#define ACTOR_HTDISPICNUM 58
#define ACTOR_HTTIMETOSLEEP 59
#define ACTOR_HTFLOORZ 60
#define ACTOR_HTCEILINGZ 61
#define ACTOR_HTLASTVX 62
#define ACTOR_HTLASTVY 63
#define ACTOR_HTBPOSX 64
#define ACTOR_HTBPOSY 65
#define ACTOR_HTBPOSZ 66
#define ACTOR_HTG_T0 67
#define ACTOR_HTG_T1 68
#define ACTOR_HTG_T2 69
#define ACTOR_HTG_T3 70
#define ACTOR_HTG_T4 71
#define ACTOR_HTG_T5 72
#define ACTOR_HTG_T 73
